<?php

$no_http_headers = true;

/* display No errors */
error_reporting(E_ERROR);

include_once(dirname(__FILE__) . "/../lib/snmp.php");

if (!isset($called_by_script_server)) {
	include_once(dirname(__FILE__) . "/../include/config.php");

	array_shift($_SERVER["argv"]);
	print call_user_func_array("ss_nbar_all", $_SERVER["argv"]);
}

function ss_nbar_all($hostname, $snmp_community, $snmp_version, $cmd, $arg, $index) {
	global $config;

	// add ifindex to these oids.
	// enable = 1 (yes) or 2 (no)
	// uptime = value of sysuptime when enabled
	$oids = array("enable" => ".1.3.6.1.4.1.9.9.244.1.1.1.1.1",
	  		"uptime" => ".1.3.6.1.4.1.9.9.244.1.1.1.1.2",
			"protos" => ".1.3.6.1.4.1.9.9.244.1.8.1.1.2"
			);

	// Add .ifindex.protocol to theses oids:-
	$nbaroids = array(	"protoname" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.2",
			"inpkts" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.3",
			"outpkts" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.4",
			"inbytes" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.5",
			"outbytes" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.6",
			"hcinpkts" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.7",
			"hcoutpkts" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.8",
			"hcinbytes" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.9",
			"hcoutbytes" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.10",
			"inbitrate"=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.11",
			"outbitrate" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.12"
			);

	// interface mib oids
	// add ifindex
	$ifoids = array("ifIndex" => ".1.3.6.1.2.1.2.2.1.1",
					"ifDescr" => ".1.3.6.1.2.1.2.2.1.2",
					"ifType" => ".1.3.6.1.2.1.2.2.1.3",
					"ifAdminStatus" => ".1.3.6.1.2.1.2.2.1.7",
					"ifOperStatus" => ".1.3.6.1.2.1.2.2.1.8",
					"ifName" => ".1.3.6.1.2.1.31.1.1.1.1",
					"ifAlias" => ".1.3.6.1.2.1.31.1.1.1.18");


	$arr_index = array();

	// Index mode - return list of indexes
	// we use a custom index (lower 8 bits = proto-index , upper 8 bits = ifindex)
	if ($cmd == "index") {
		$arr_index = ss_nbar_get_indexes(&$oids, &$nbaroids, &$ifoids, $hostname, $snmp_community, $snmp_version);

		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "\n";
		}
	}elseif ($cmd == "query") {	// Query Mode return list of Index vs Field(argv:5)
	
		$arr_index = ss_nbar_get_indexes(&$oids, &$nbaroids, &$ifoids, $hostname, $snmp_community, $snmp_version);

		switch ($arg) {
		case 'index':
			for ($i=0;($i<sizeof($arr_index));$i++) {
				print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
			}
			break;
		case 'protoindex':
		case 'protoname':
		case 'inpkts':
		case 'outpkts':
		case 'inbytes':
		case 'outbytes':
		case 'hcinpkts':
		case 'hcoutpkts':
		case 'hcinbytes':
		case 'hcoutbytes':
		case 'inbitrate':
		case 'outbitrate':
			$arr = ss_nbar_get_info(&$oids, &$nbaroids, &$ifoids, &$arr_index, $hostname, $snmp_community, $snmp_version, $arg);
			for ($i=0;($i<sizeof($arr_index));$i++) {
				print $arr_index[$i] . "!" . $arr[$i] . "\n";
			}
			break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
			$arr = ss_nbar_get_ifinfo(&$oids, &$nbaroids, &$ifoids, &$arr_index, $hostname, $snmp_community, $snmp_version, $arg);
			for ($i=0;($i<sizeof($arr_index));$i++) {
				print $arr_index[$i] . "!" . $arr[$i] . "\n";
			}
			break;
		}
	}elseif ($cmd == "get") { // Get Mode - return Individual Value for Field (argv:5) and Index (argv:6)


		switch ($arg) {
		case 'index':
			return $index;
			break;
		case 'protoindex':
		case 'protoname':
		case 'inpkts':
		case 'outpkts':
		case 'inbytes':
		case 'outbytes':
		case 'hcinpkts':
		case 'hcoutpkts':
		case 'hcinbytes':
		case 'hcoutbytes':
		case 'inbitrate':
		case 'outbitrate':
			$t_oid = $nbaroids[$arg].".".strval(ss_nbar_decide_cindex($index,1)).".".strval(ss_nbar_decide_cindex($index,2));
			return cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", 161, 1000);
			break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
			$t_oid = $ifoids[$arg].".".ss_nbar_decide_cindex($index,1);
			return cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", 161, 1000);
			break;

		}
	}
}

// Get Specific Info for ISDN Index from ifIndex
function ss_nbar_get_ifinfo(&$oids, &$nbaroids, &$ifoids, &$arr_index, $hostname, $snmp_community, $snmp_version, $arg) {
	global $config;

	$return_arr = array();

	// Cycle Custom Index and return reqd argument..'
	for ($i=0;($i<sizeof($arr_index));$i++) {
		// build oid
		$t_oid = $ifoids[$arg].".".strval(ss_nbar_decide_cindex($arr_index[$i],1));
		$return_arr[$i] = cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", 161, 1000);
	}

	return $return_arr;
}

function ss_nbar_get_info(&$oids, &$nbaroids, &$ifoids, &$arr_index, $hostname, $snmp_community, $snmp_version,$arg) {
	global $config;

	$return_arr = array();

	// Cycle Custom Index and return reqd argument..'
	for ($i=0;($i<sizeof($arr_index));$i++) {
		// build oid
		$t_oid = $nbaroids[$arg].".".strval(ss_nbar_decide_cindex($arr_index[$i],1)).".".strval(ss_nbar_decide_cindex($arr_index[$i],2));
		$return_arr[$i] = cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, "", "", 161, 1000);
	}

	return $return_arr;
}

function ss_nbar_get_indexes(&$oids, &$nbaroids, &$ifoids, $hostname, $snmp_community, $snmp_version) {
	global $config;

	$return_arr = array();

	//	1st we walk the enable to table to find enabled interfaces
	$walkit = cacti_snmp_walk($hostname, $snmp_community, $oids["enable"], $snmp_version, "", "", 161, 1000);

	$arr = ss_nbar_reindex($walkit);

	$arr_proto = ss_nbar_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["protos"], $snmp_version, "", "", 161, 1000));

	$index_count = 0;

	for ($i=0;($i<sizeof($arr));$i++) {
		$test=cacti_snmp_get($hostname, $snmp_community,$ifoids["ifIndex"].".".($i+1), $snmp_version, "", "", 161, 1000);
		if ((strpos($arr[$i], "1") !== FALSE) and (strpos($test,"OID") == FALSE)) {
			for ($j=0;($j<sizeof($arr_proto));$j++) {
				$return_arr[$index_count] = ss_nbar_encode_cindex(($i+1),($j+1));
				$index_count++;
			}
		}
	}

	return $return_arr;
}

function ss_nbar_reindex($arr) {
	$return_arr = array();
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}

	return $return_arr;
}

function ss_nbar_encode_cindex($ifindex,$protoindex) {
	// encode custom index
	$temp = $ifindex << 8;
	$cindex = $temp | $protoindex;

	return $cindex;
}

function ss_nbar_decide_cindex($cindex, $item) {
	// decode custom index into ifindex ($item=1) or protoindex ($item=2)

	if ($item <> 1 and $item <> 2) {
		return 0;
	}

	switch ($item) {
	case 1:
		// return ifindex
		$ret = $cindex >> 8;
		break;
	case 2:
		// return protoindex
		$ret = $cindex & 255;
		break;
	}

	return $ret;
}
?>